// JavaScript Document
// This code was written with reference to lecture notes of
// Mark Humphrys and W3 Schools Website http://www.w3schools.com/.


// XMLHttpRequest object:
var xhr = false;


// this function displays the string in main field
function outputString( string )
{
	document.getElementById("loading").style.display = "none";
	document.getElementById("container").style.opacity = "1.0";
	document.getElementById("main").innerHTML = string;
}


// this script is called by clicking on search button
function runScript()
{
	// read value in search box
	var word = document.input.query.value;
	// window of flickr photos 
	// activate to display loading image while photos are loading into the page
	//document.getElementById("main").innerHTML = '';
	document.getElementById("loading").style.display = "block";
	document.getElementById("container").style.opacity = "0.2";
		
	if (word.length==" ")
  	{
  		outputString( "<p>The search box is empty. Please search again.</p>" );
  	}
	
	else
	{   
		// assign the url for calling the php script
		var urlstring = "FlickrFeeds.php?q="+word;
 	
 		//alert( urlstring );
		
		// call makeRequest method
 		makeRequest(urlstring);
	}
 	return false;
}

function makeRequest(url)
{
	if (window.XMLHttpRequest) // if supported by browser
 	{	// code for IE7+, Firefox, Chrome, Opera, Safari
 		xhr = new XMLHttpRequest();
 	}
 	
	else
 	{	// code for IE6, IE5
  		xhr=new ActiveXObject("Microsoft.XMLHTTP");
	}
 	
 	if (xhr)
 	{	// this function is called when xhr is ready
		xhr.onreadystatechange = showContents;
 		
		// alert( url );
 		// GET url on the same server as this  
		xhr.open("GET", url, true);
		
 		xhr.send();
	}
 
 	else
 	{
 		outputString ( "<p>Sorry, but I couldn't create an XMLHttpRequest</p>" );
	}
} // end makeRequest method


// this method show content of parsing XML file
function showContents()
{
 if ( xhr.readyState == 4 && xhr.status == 200)  // xhr has finished (first condition) and HTTP code 200
 { 
 	if ( xhr.responseXML.xml )			// in IE
	{   
		// parse XML
		// call parseit method
		xmlDoc = xhr.responseXML;
		parseit ( xmlDoc );	// structured XML object
	}

	else if ( xhr.responseText )		// in other browsers
	{	
		// parse XML
		parser = new DOMParser(); 
		xmlDoc = parser.parseFromString( xhr.responseText, "text/xml");
		//alert(xmlDoc);
		// call parseit method
		parseit ( xmlDoc );	
	}

	else
	{ 
   		outputString ( "<p>Error: XMLHttpRequest failed. Status: " + xhr.status +", ReadyState: " + xhr.readyState +"</p>");
	}
 }
}

// This method parses XML to a table format. The table contains three columns 
// and up to seven rows. It depends on flickr loaded photos. Each cell in 
// the table contains "From", a name of author and his photo.
function parseit ( xmlDoc )
{	
	// read value in search box
	var word = document.input.query.value;
	// local variables
	var i,j,k;
	var	txt =" ";
	
	txt="<div id='mainflickr'><table>" +
	"<tr><th>Recent Flickr Photos</th></tr>";
    
	// get entry tag in xml 
	var x = xmlDoc.getElementsByTagName("entry");
	
	// if flickr feeds are empty, there is no photos to parse.		
	if (x.length == 0)
	{
		txt = txt + "<tr><td style='font-size:14px; padding:10px'>No Photos Found for \""+word+"\". Search again.</td></tr>";
	}
	
	// loop to start parsing the flickr photos    
	for (i=0;i<x.length;i++)
    {
			
		txt=txt + "<tr>"; // start a row
	
		// get subtags of the "entry" tag
   		var xx=x[i].getElementsByTagName("content");
		var yy=x[i].getElementsByTagName("name");
		var zz=x[i].getElementsByTagName("uri");
		
    	
   	 	try
     	{
			// get content from those tags  
	 		var node = xx[0].firstChild.nodeValue;   // photo
			var node1 = yy[0].firstChild.nodeValue;  // name of the author
	 		var node2 = zz[0].firstChild.nodeValue;  // link to the author flickr site
				
	 		var node3 = "<p style='font-size:12px; padding:10px'> From <a href='" + node2 + "'>" + node1 + "</a></p>";
			
			// fill a cell in the first column with From, name of the author and his photo 
     		txt=txt + "<td>" + node3 + node + "</td>";
   	 	}// end try
        	
	 	catch (er)
     	{
     		txt=txt + "<td>&nbsp</td>";
     	}
	 
	    // get the next entry tag and fill a cell in the second column
	 	j = i+1;
    	
		if( j < x.length)
		{	
			xx=x[j].getElementsByTagName("content");
			yy=x[j].getElementsByTagName("name");
			zz=x[j].getElementsByTagName("uri");
        
       		try
        	{
				// get content in the tags
				node = xx[0].firstChild.nodeValue;	 // photo
				//node = node.substring(node.lastIndexOf("<a href="), node.lastIndexOf("</a>"));
		 		node1 = yy[0].firstChild.nodeValue;  // name of the author
		 		node2 = zz[0].firstChild.nodeValue;  // link to the author flickr site
				
		 		node3 = "<p style='font-size:12px; padding:10px'> From <a href='" + node2 + "'>" + node1 + "</a></p>";
				
				// fill a cell in the second column with From, name of the author and his photo	
         		txt=txt + "<td>" + node3 + node + "</td>";
        	}// end try
        	
			catch (er)
        	{
        		txt=txt + "<td>Error</td>";
        	}
		
			// get the next entry tag and fill a cell in the third column		
			k = j+1;	
		}//end if( j<x.length)
	
		
		else
		{	
			// assign j to i and j to k if it the last entry tag is reached.
			i=j;
			k=j;
		}
	
	
		if( k < x.length )
		{
			xx=x[k].getElementsByTagName("content");
			yy=x[k].getElementsByTagName("name");
			zz=x[k].getElementsByTagName("uri");
    	
    		try
        	{
				// get content in the tags
				node = xx[0].firstChild.nodeValue;	  // photo
				node1 = yy[0].firstChild.nodeValue;   // name of the author
		 		node2 = zz[0].firstChild.nodeValue;   // link to the author flickr site
				
			 	node3 = "<p style='font-size:12px; padding:10px'> From <a href='" + node2 + "'>" + node1 + "</a></p>";
			
				// fill a cell in the third column with From, name of the author and his photo	
        		txt=txt + "<td>" + node3 + node + "</td>";
        	}// end try
        	
			catch (er)
        	{
        		txt=txt + "<td>Error</td>";
        	}
		
		}// end if ( k<x.length)
		
		// assign k to i  to continue in the for loop
		i=k;
		
		txt=txt + "</tr>";  // end a row

      } // end for loop
		  
    txt=txt + "</table></div>";
	// fill HTML field main with the content
	document.getElementById("loading").style.display = "none";
	document.getElementById("container").style.opacity = "1.0";
    document.getElementById('main').innerHTML=txt;
		

}// end parseit method
